import { createAutoResolveWeakCache } from '../util/AutoResolve.mjs';
import { isDefined } from '../util/util.mjs';
import { createSpellingDictionary } from './createSpellingDictionary.mjs';
import { createFlagWordsDictionary } from './FlagWordsDictionary.mjs';
import { createIgnoreWordsDictionary } from './IgnoreWordsDictionary.mjs';
import { createCollection } from './SpellingDictionaryCollection.mjs';
import { createSuggestDictionary } from './SuggestDictionary.mjs';
const cache = createAutoResolveWeakCache();
export function createInlineSpellingDictionary(inlineDict, source) {
    return cache.get(inlineDict, () => {
        const { words, flagWords, ignoreWords, suggestWords, name } = inlineDict;
        const dictSources = [
            words && createSpellingDictionary(words, name + '-words', source, inlineDict),
            flagWords && createFlagWordsDictionary(flagWords, name + '-flag-words', source),
            ignoreWords && createIgnoreWordsDictionary(ignoreWords, name + '-ignore-words', source),
            suggestWords && createSuggestDictionary(suggestWords, name + '-suggest', source),
        ].filter(isDefined);
        return createCollection(dictSources, name, source);
    });
}
